System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Node, SystemEventType, Graphics, Vec2, PhysicsSystem2D, ERaycast2DType, Intersection2D, RigidBody2D, PolygonCollider2D, Vec3, _dec, _dec2, _class, _class2, _descriptor, _temp, _crd, ccclass, type, EPSILON, POINT_SQR_EPSILON, CuttingObjects;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function compare(a, b) {
    if (a.fraction > b.fraction) {
      return 1;
    } else if (a.fraction < b.fraction) {
      return -1;
    }

    return 0;
  }

  function equals(a, b, epsilon) {
    epsilon = epsilon === undefined ? EPSILON : epsilon;
    return Math.abs(a - b) < epsilon;
  }

  function pointInLine(point, a, b) {
    return Intersection2D.pointLineDistance(point, a, b, true) < 1;
  }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      SystemEventType = _cc.SystemEventType;
      Graphics = _cc.Graphics;
      Vec2 = _cc.Vec2;
      PhysicsSystem2D = _cc.PhysicsSystem2D;
      ERaycast2DType = _cc.ERaycast2DType;
      Intersection2D = _cc.Intersection2D;
      RigidBody2D = _cc.RigidBody2D;
      PolygonCollider2D = _cc.PolygonCollider2D;
      Vec3 = _cc.Vec3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1df7a4qxKpHkqVAh/8H35NM", "cutting-objects", undefined);

      ({
        ccclass,
        type
      } = _decorator); // http://www.emanueleferonato.com/2011/08/05/slicing-splitting-and-cutting-objects-with-box2d-part-4-using-real-graphics/

      EPSILON = 0.1;
      POINT_SQR_EPSILON = 5;

      _export("CuttingObjects", CuttingObjects = (_dec = ccclass('CuttingObjects'), _dec2 = type(Graphics), _dec(_class = (_class2 = (_temp = class CuttingObjects extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "touching", false);

          _initializerDefineProperty(this, "ctx", _descriptor, this);

          _defineProperty(this, "touchStartPoint", new Vec2());

          _defineProperty(this, "touchPoint", new Vec2());

          _defineProperty(this, "r1", []);

          _defineProperty(this, "r2", []);

          _defineProperty(this, "results", []);
        }

        start() {
          this.node.on(SystemEventType.TOUCH_START, this.onTouchStart, this);
          this.node.on(SystemEventType.TOUCH_END, this.onTouchEnd, this);
          this.node.on(SystemEventType.TOUCH_MOVE, this.onTouchMove, this);
          this.ctx.node.worldPosition = Vec3.ZERO;
        }

        onTouchStart(event) {
          this.touching = true;
          this.r1.length = 0;
          this.r2.length = 0;
          this.results.length = 0;
          this.touchStartPoint.set(event.getUILocation());
          this.touchPoint.set(event.getUILocation());
        }

        onTouchMove(event) {
          this.touchPoint.set(event.getUILocation());
        }

        onTouchEnd(event) {
          this.touchPoint.set(event.getUILocation());
          this.recalcResults();
          this.touching = false;
          if (equals(Vec2.squaredDistance(this.touchStartPoint, event.getUILocation()), 0)) return; // recalculate fraction, make fraction from one direction

          this.r2.forEach(r => {
            r.fraction = 1 - r.fraction;
          });
          let results = this.results;
          let pairs = [];

          for (let i = 0; i < results.length; i++) {
            let find = false;
            let result = results[i];

            for (let j = 0; j < pairs.length; j++) {
              let pair = pairs[j];

              if (pair[0] && result.collider === pair[0].collider) {
                find = true; // one collider may contains several fixtures, so raycast may through the inner fixture side
                // we need remove them from the result

                let r = pair.find(r => {
                  return Vec2.squaredDistance(r.point, result.point) <= POINT_SQR_EPSILON;
                });

                if (r) {
                  pair.splice(pair.indexOf(r), 1);
                } else {
                  pair.push(result);
                }

                break;
              }
            }

            if (!find) {
              pairs.push([result]);
            }
          }

          for (let i = 0; i < pairs.length; i++) {
            let pair = pairs[i];

            if (pair.length < 2) {
              continue;
            } // sort pair with fraction


            pair = pair.sort(compare);
            let splitResults = []; // first calculate all results, not split collider right now

            for (let j = 0; j < pair.length - 1; j += 2) {
              let r1 = pair[j];
              let r2 = pair[j + 1];

              if (r1 && r2) {
                this.split(r1.collider, r1.point, r2.point, splitResults);
              }
            }

            if (splitResults.length <= 0) {
              continue;
            }

            let collider = pair[0].collider;
            let maxPointsResult;

            for (let j = 0; j < splitResults.length; j++) {
              let splitResult = splitResults[j];

              for (let k = 0; k < splitResult.length; k++) {
                if (typeof splitResult[k] === 'number') {
                  splitResult[k] = collider.points[splitResult[k]];
                }
              }

              if (!maxPointsResult || splitResult.length > maxPointsResult.length) {
                maxPointsResult = splitResult;
              }
            }

            if (maxPointsResult.length < 3) {
              continue;
            } // keep max length points to origin collider


            collider.points = maxPointsResult;
            collider.apply();
            let body = collider.body;

            for (let j = 0; j < splitResults.length; j++) {
              let splitResult = splitResults[j];
              if (splitResult.length < 3) continue;
              if (splitResult == maxPointsResult) continue; // create new body

              let node = new Node();
              node.parent = this.node;
              node.worldPosition = body.node.worldPosition;
              node.worldRotation = body.node.worldRotation;
              node.addComponent(RigidBody2D);
              let newCollider = node.addComponent(PolygonCollider2D);
              newCollider.points = splitResult;
              newCollider.apply();
            }
          }
        }

        split(collider, p1, p2, splitResults) {
          let body = collider.body;
          let points = collider.points; // The manager.rayCast() method returns points in world coordinates, so use the body.getLocalPoint() to convert them to local coordinates.

          p1 = body.getLocalPoint(p1);
          p2 = body.getLocalPoint(p2);
          let newSplitResult1 = [p1, p2];
          let newSplitResult2 = [p2, p1];
          let index1, index2;

          for (let i = 0; i < points.length; i++) {
            let pp1 = points[i];
            let pp2 = i === points.length - 1 ? points[0] : points[i + 1];

            if (index1 === undefined && pointInLine(p1, pp1, pp2)) {
              index1 = i;
            } else if (index2 === undefined && pointInLine(p2, pp1, pp2)) {
              index2 = i;
            }

            if (index1 !== undefined && index2 !== undefined) {
              break;
            }
          } // console.log(index1 + ' : ' + index2);


          if (index1 === undefined || index2 === undefined) {
            debugger;
            return;
          }

          let splitResult,
              indiceIndex1 = index1,
              indiceIndex2 = index2;

          if (splitResults.length > 0) {
            for (let i = 0; i < splitResults.length; i++) {
              let indices = splitResults[i];
              indiceIndex1 = indices.indexOf(index1);
              indiceIndex2 = indices.indexOf(index2);

              if (indiceIndex1 !== -1 && indiceIndex2 !== -1) {
                splitResult = splitResults.splice(i, 1)[0];
                break;
              }
            }
          }

          if (!splitResult) {
            splitResult = points.map((p, i) => {
              return i;
            });
          }

          for (let i = indiceIndex1 + 1; i !== indiceIndex2 + 1; i++) {
            if (i >= splitResult.length) {
              i = 0;
            }

            let p = splitResult[i];
            p = typeof p === 'number' ? points[p] : p;

            if (Vec2.squaredDistance(p, p1) < POINT_SQR_EPSILON || Vec2.squaredDistance(p, p2) < POINT_SQR_EPSILON) {
              continue;
            }

            newSplitResult2.push(splitResult[i]);
          }

          for (let i = indiceIndex2 + 1; i !== indiceIndex1 + 1; i++) {
            if (i >= splitResult.length) {
              i = 0;
            }

            let p = splitResult[i];
            p = typeof p === 'number' ? points[p] : p;

            if (Vec2.squaredDistance(p, p1) < POINT_SQR_EPSILON || Vec2.squaredDistance(p, p2) < POINT_SQR_EPSILON) {
              continue;
            }

            newSplitResult1.push(splitResult[i]);
          }

          splitResults.push(newSplitResult1);
          splitResults.push(newSplitResult2);
        }

        recalcResults() {
          if (!this.touching) return;
          let startPoint = this.touchStartPoint;
          let point = this.touchPoint;
          this.ctx.clear();
          this.ctx.moveTo(startPoint.x, startPoint.y);
          this.ctx.lineTo(point.x, point.y);
          this.ctx.stroke(); // manager.rayCast() method calls this function only when it sees that a given line gets into the body - it doesnt see when the line gets out of it.
          // I must have 2 intersection points with a body so that it can be sliced, thats why I use manager.rayCast() again, but this time from B to A - that way the point, at which BA enters the body is the point at which AB leaves it!

          let r1 = PhysicsSystem2D.instance.raycast(startPoint, point, ERaycast2DType.All);
          let r2 = PhysicsSystem2D.instance.raycast(point, startPoint, ERaycast2DType.All);
          let results = r1.concat(r2);
          results = results.filter(r => r.collider instanceof PolygonCollider2D);

          for (let i = 0; i < results.length; i++) {
            let p = results[i].point;
            this.ctx.circle(p.x, p.y, 5);
          }

          this.ctx.fill();
          this.r1 = r1.concat([]);
          this.r2 = r2.concat([]);
          this.results = results;
        } // called every frame, uncomment this function to activate update callback


        update(dt) {
          // body maybe moving, need calc raycast results in update
          this.recalcResults();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ctx", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=cutting-objects.js.map