System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, GraphicsComponent, Vec2, PhysicsSystem2D, Vec3, _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp, _crd, ccclass, property, type, RayCastReflection;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      GraphicsComponent = _cc.GraphicsComponent;
      Vec2 = _cc.Vec2;
      PhysicsSystem2D = _cc.PhysicsSystem2D;
      Vec3 = _cc.Vec3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7329bOEJuhES78MiEDvhOmt", "raycast-reflection", undefined);

      ({
        ccclass,
        property,
        type
      } = _decorator);

      _export("RayCastReflection", RayCastReflection = (_dec = ccclass('RayCastReflection'), _dec2 = type(GraphicsComponent), _dec(_class = (_class2 = (_temp = class RayCastReflection extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "radius", _descriptor, this);

          _initializerDefineProperty(this, "ctx", _descriptor2, this);

          _defineProperty(this, "angle", 0);

          _defineProperty(this, "begin", new Vec2());

          _defineProperty(this, "end", new Vec2());

          _defineProperty(this, "remainLength", 0);
        }

        start() {
          if (!this.ctx) {
            return;
          }

          this.ctx.node.worldPosition = Vec3.ZERO;
          this.angle = 0;
        }

        update(dt) {
          if (!this.ctx) {
            return;
          }

          this.angle += Math.PI / 20 * dt;
          let p1 = this.begin.set(this.node.worldPosition.x, this.node.worldPosition.y);
          let p2 = this.end.set(Math.cos(this.angle), Math.sin(this.angle)).multiplyScalar(this.radius).add(p1);
          this.ctx.clear();
          this.remainLength = this.radius;
          this.raycast(p1, p2);
        }

        raycast(p1, p2) {
          let result = PhysicsSystem2D.instance.raycast(p1, p2)[0];

          if (result) {
            p2.set(result.point);
            this.ctx.circle(p2.x, p2.y, 5);
            this.ctx.fill();
          }

          this.ctx.moveTo(p1.x, p1.y);
          this.ctx.lineTo(p2.x, p2.y);
          this.ctx.stroke();
          if (!result) return;
          this.remainLength = this.remainLength - Vec2.distance(p2, p1);
          if (this.remainLength < 1) return;
          p1.set(p2);
          p2.set(result.normal).multiplyScalar(this.remainLength).add(p1);
          this.raycast(p1, p2);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "radius", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1000;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ctx", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=raycast-reflection.js.map