System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Node, SystemEventType, Graphics, Vec2, PhysicsSystem2D, ERaycast2DType, Intersection2D, RigidBody2D, PolygonCollider2D, Vec3, _dec, _dec2, _class, _class2, _descriptor, _temp, _crd, ccclass, type, EPSILON, POINT_SQR_EPSILON, CuttingObjects;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function compare(a, b) {
    if (a.fraction > b.fraction) {
      return 1;
    } else if (a.fraction < b.fraction) {
      return -1;
    }

    return 0;
  }

  function equals(a, b, epsilon) {
    epsilon = epsilon === undefined ? EPSILON : epsilon;
    return Math.abs(a - b) < epsilon;
  }

  function pointInLine(point, a, b) {
    return Intersection2D.pointLineDistance(point, a, b, true) < 1;
  }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      SystemEventType = _cc.SystemEventType;
      Graphics = _cc.Graphics;
      Vec2 = _cc.Vec2;
      PhysicsSystem2D = _cc.PhysicsSystem2D;
      ERaycast2DType = _cc.ERaycast2DType;
      Intersection2D = _cc.Intersection2D;
      RigidBody2D = _cc.RigidBody2D;
      PolygonCollider2D = _cc.PolygonCollider2D;
      Vec3 = _cc.Vec3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1df7a4qxKpHkqVAh/8H35NM", "cutting-objects", undefined);

      ccclass = _decorator.ccclass;
      type = _decorator.type; // http://www.emanueleferonato.com/2011/08/05/slicing-splitting-and-cutting-objects-with-box2d-part-4-using-real-graphics/

      EPSILON = 0.1;
      POINT_SQR_EPSILON = 5;

      _export("CuttingObjects", CuttingObjects = (_dec = ccclass('CuttingObjects'), _dec2 = type(Graphics), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(CuttingObjects, _Component);

        function CuttingObjects() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _defineProperty(_assertThisInitialized(_this), "touching", false);

          _initializerDefineProperty(_assertThisInitialized(_this), "ctx", _descriptor, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "touchStartPoint", new Vec2());

          _defineProperty(_assertThisInitialized(_this), "touchPoint", new Vec2());

          _defineProperty(_assertThisInitialized(_this), "r1", []);

          _defineProperty(_assertThisInitialized(_this), "r2", []);

          _defineProperty(_assertThisInitialized(_this), "results", []);

          return _this;
        }

        var _proto = CuttingObjects.prototype;

        _proto.start = function start() {
          this.node.on(SystemEventType.TOUCH_START, this.onTouchStart, this);
          this.node.on(SystemEventType.TOUCH_END, this.onTouchEnd, this);
          this.node.on(SystemEventType.TOUCH_MOVE, this.onTouchMove, this);
          this.ctx.node.worldPosition = Vec3.ZERO;
        };

        _proto.onTouchStart = function onTouchStart(event) {
          this.touching = true;
          this.r1.length = 0;
          this.r2.length = 0;
          this.results.length = 0;
          this.touchStartPoint.set(event.getUILocation());
          this.touchPoint.set(event.getUILocation());
        };

        _proto.onTouchMove = function onTouchMove(event) {
          this.touchPoint.set(event.getUILocation());
        };

        _proto.onTouchEnd = function onTouchEnd(event) {
          this.touchPoint.set(event.getUILocation());
          this.recalcResults();
          this.touching = false;
          if (equals(Vec2.squaredDistance(this.touchStartPoint, event.getUILocation()), 0)) return; // recalculate fraction, make fraction from one direction

          this.r2.forEach(function (r) {
            r.fraction = 1 - r.fraction;
          });
          var results = this.results;
          var pairs = [];

          var _loop = function _loop(i) {
            var find = false;
            var result = results[i];

            for (var _j3 = 0; _j3 < pairs.length; _j3++) {
              var _pair = pairs[_j3];

              if (_pair[0] && result.collider === _pair[0].collider) {
                find = true; // one collider may contains several fixtures, so raycast may through the inner fixture side
                // we need remove them from the result

                var r = _pair.find(function (r) {
                  return Vec2.squaredDistance(r.point, result.point) <= POINT_SQR_EPSILON;
                });

                if (r) {
                  _pair.splice(_pair.indexOf(r), 1);
                } else {
                  _pair.push(result);
                }

                break;
              }
            }

            if (!find) {
              pairs.push([result]);
            }
          };

          for (var i = 0; i < results.length; i++) {
            _loop(i);
          }

          for (var _i = 0; _i < pairs.length; _i++) {
            var pair = pairs[_i];

            if (pair.length < 2) {
              continue;
            } // sort pair with fraction


            pair = pair.sort(compare);
            var splitResults = []; // first calculate all results, not split collider right now

            for (var j = 0; j < pair.length - 1; j += 2) {
              var r1 = pair[j];
              var r2 = pair[j + 1];

              if (r1 && r2) {
                this.split(r1.collider, r1.point, r2.point, splitResults);
              }
            }

            if (splitResults.length <= 0) {
              continue;
            }

            var collider = pair[0].collider;
            var maxPointsResult = void 0;

            for (var _j = 0; _j < splitResults.length; _j++) {
              var splitResult = splitResults[_j];

              for (var k = 0; k < splitResult.length; k++) {
                if (typeof splitResult[k] === 'number') {
                  splitResult[k] = collider.points[splitResult[k]];
                }
              }

              if (!maxPointsResult || splitResult.length > maxPointsResult.length) {
                maxPointsResult = splitResult;
              }
            }

            if (maxPointsResult.length < 3) {
              continue;
            } // keep max length points to origin collider


            collider.points = maxPointsResult;
            collider.apply();
            var body = collider.body;

            for (var _j2 = 0; _j2 < splitResults.length; _j2++) {
              var _splitResult = splitResults[_j2];
              if (_splitResult.length < 3) continue;
              if (_splitResult == maxPointsResult) continue; // create new body

              var node = new Node();
              node.parent = this.node;
              node.worldPosition = body.node.worldPosition;
              node.worldRotation = body.node.worldRotation;
              node.addComponent(RigidBody2D);
              var newCollider = node.addComponent(PolygonCollider2D);
              newCollider.points = _splitResult;
              newCollider.apply();
            }
          }
        };

        _proto.split = function split(collider, p1, p2, splitResults) {
          var body = collider.body;
          var points = collider.points; // The manager.rayCast() method returns points in world coordinates, so use the body.getLocalPoint() to convert them to local coordinates.

          p1 = body.getLocalPoint(p1);
          p2 = body.getLocalPoint(p2);
          var newSplitResult1 = [p1, p2];
          var newSplitResult2 = [p2, p1];
          var index1, index2;

          for (var i = 0; i < points.length; i++) {
            var pp1 = points[i];
            var pp2 = i === points.length - 1 ? points[0] : points[i + 1];

            if (index1 === undefined && pointInLine(p1, pp1, pp2)) {
              index1 = i;
            } else if (index2 === undefined && pointInLine(p2, pp1, pp2)) {
              index2 = i;
            }

            if (index1 !== undefined && index2 !== undefined) {
              break;
            }
          } // console.log(index1 + ' : ' + index2);


          if (index1 === undefined || index2 === undefined) {
            debugger;
            return;
          }

          var splitResult,
              indiceIndex1 = index1,
              indiceIndex2 = index2;

          if (splitResults.length > 0) {
            for (var _i2 = 0; _i2 < splitResults.length; _i2++) {
              var indices = splitResults[_i2];
              indiceIndex1 = indices.indexOf(index1);
              indiceIndex2 = indices.indexOf(index2);

              if (indiceIndex1 !== -1 && indiceIndex2 !== -1) {
                splitResult = splitResults.splice(_i2, 1)[0];
                break;
              }
            }
          }

          if (!splitResult) {
            splitResult = points.map(function (p, i) {
              return i;
            });
          }

          for (var _i3 = indiceIndex1 + 1; _i3 !== indiceIndex2 + 1; _i3++) {
            if (_i3 >= splitResult.length) {
              _i3 = 0;
            }

            var p = splitResult[_i3];
            p = typeof p === 'number' ? points[p] : p;

            if (Vec2.squaredDistance(p, p1) < POINT_SQR_EPSILON || Vec2.squaredDistance(p, p2) < POINT_SQR_EPSILON) {
              continue;
            }

            newSplitResult2.push(splitResult[_i3]);
          }

          for (var _i4 = indiceIndex2 + 1; _i4 !== indiceIndex1 + 1; _i4++) {
            if (_i4 >= splitResult.length) {
              _i4 = 0;
            }

            var _p = splitResult[_i4];
            _p = typeof _p === 'number' ? points[_p] : _p;

            if (Vec2.squaredDistance(_p, p1) < POINT_SQR_EPSILON || Vec2.squaredDistance(_p, p2) < POINT_SQR_EPSILON) {
              continue;
            }

            newSplitResult1.push(splitResult[_i4]);
          }

          splitResults.push(newSplitResult1);
          splitResults.push(newSplitResult2);
        };

        _proto.recalcResults = function recalcResults() {
          if (!this.touching) return;
          var startPoint = this.touchStartPoint;
          var point = this.touchPoint;
          this.ctx.clear();
          this.ctx.moveTo(startPoint.x, startPoint.y);
          this.ctx.lineTo(point.x, point.y);
          this.ctx.stroke(); // manager.rayCast() method calls this function only when it sees that a given line gets into the body - it doesnt see when the line gets out of it.
          // I must have 2 intersection points with a body so that it can be sliced, thats why I use manager.rayCast() again, but this time from B to A - that way the point, at which BA enters the body is the point at which AB leaves it!

          var r1 = PhysicsSystem2D.instance.raycast(startPoint, point, ERaycast2DType.All);
          var r2 = PhysicsSystem2D.instance.raycast(point, startPoint, ERaycast2DType.All);
          var results = r1.concat(r2);
          results = results.filter(function (r) {
            return r.collider instanceof PolygonCollider2D;
          });

          for (var i = 0; i < results.length; i++) {
            var p = results[i].point;
            this.ctx.circle(p.x, p.y, 5);
          }

          this.ctx.fill();
          this.r1 = r1.concat([]);
          this.r2 = r2.concat([]);
          this.results = results;
        } // called every frame, uncomment this function to activate update callback
        ;

        _proto.update = function update(dt) {
          // body maybe moving, need calc raycast results in update
          this.recalcResults();
        };

        return CuttingObjects;
      }(Component), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ctx", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=cutting-objects.js.map