System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, PhysicsSystem2D, Vec2, Collider2D, Contact2DType, _dec, _class, _temp, _crd, ccclass, property, Gravity;

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      PhysicsSystem2D = _cc.PhysicsSystem2D;
      Vec2 = _cc.Vec2;
      Collider2D = _cc.Collider2D;
      Contact2DType = _cc.Contact2DType;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1c502jFEo9JppgcqIaAmGKm", "gravity", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("Gravity", Gravity = (_dec = ccclass('Gravity'), _dec(_class = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(Gravity, _Component);

        function Gravity() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _defineProperty(_assertThisInitialized(_this), "collider", void 0);

          _defineProperty(_assertThisInitialized(_this), "bodies", void 0);

          _defineProperty(_assertThisInitialized(_this), "originGravity", new Vec2());

          return _this;
        }

        var _proto = Gravity.prototype;

        _proto.onEnable = function onEnable() {
          this.bodies = [];
          this.collider = this.getComponent(Collider2D);
          this.originGravity.set(PhysicsSystem2D.instance.gravity);
          PhysicsSystem2D.instance.gravity = Vec2.ZERO;
          this.collider.on(Contact2DType.BEGIN_CONTACT, this.onBeginContact, this);
          this.collider.on(Contact2DType.END_CONTACT, this.onEndContact, this);
        };

        _proto.onDisable = function onDisable() {
          PhysicsSystem2D.instance.gravity = this.originGravity;
        };

        _proto.onBeginContact = function onBeginContact(selfCollider, otherCollider, contact) {
          this.bodies.push(otherCollider.body);
        };

        _proto.onEndContact = function onEndContact(selfCollider, otherCollider, contact) {
          var index = this.bodies.indexOf(otherCollider.body);

          if (index !== -1) {
            this.bodies.splice(index, 1);
          }
        } // called every frame, uncomment this function to activate update callback
        ;

        _proto.update = function update(dt) {
          if (!this.collider) {
            return;
          }

          var bodies = this.bodies;

          for (var i = 0; i < bodies.length; i++) {
            this._applyForce(bodies[i]);
          }
        };

        _proto._applyForce = function _applyForce(body) {};

        return Gravity;
      }(Component), _temp)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=gravity.js.map