System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Vec2, Collider2D, Contact2DType, PHYSICS_2D_PTM_RATIO, _dec, _class, _crd, ccclass, property, pointVelPlatform, pointVelOther, relativeVel, relativePoint, OneWayPlatform;

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Vec2 = _cc.Vec2;
      Collider2D = _cc.Collider2D;
      Contact2DType = _cc.Contact2DType;
      PHYSICS_2D_PTM_RATIO = _cc.PHYSICS_2D_PTM_RATIO;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "a2515kOpeZLH49QO1aU0qn1", "one-way-platform", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;
      pointVelPlatform = new Vec2();
      pointVelOther = new Vec2();
      relativeVel = new Vec2();
      relativePoint = new Vec2();

      _export("OneWayPlatform", OneWayPlatform = (_dec = ccclass('OneWayPlatform'), _dec(_class = /*#__PURE__*/function (_Component) {
        _inheritsLoose(OneWayPlatform, _Component);

        function OneWayPlatform() {
          return _Component.apply(this, arguments) || this;
        }

        var _proto = OneWayPlatform.prototype;

        _proto.start = function start() {
          // Your initialization goes here.
          var collider = this.getComponent(Collider2D);
          collider.on(Contact2DType.BEGIN_CONTACT, this.onBeginContact, this);
        };

        _proto.onBeginContact = function onBeginContact(selfCollider, otherCollider, contact) {
          var otherBody = otherCollider.body;
          var platformBody = selfCollider.body;
          var worldManifold = contact.getWorldManifold();
          var points = worldManifold.points; //check if contact points are moving into platform

          for (var i = 0; i < points.length; i++) {
            platformBody.getLinearVelocityFromWorldPoint(points[i], pointVelPlatform);
            otherBody.getLinearVelocityFromWorldPoint(points[i], pointVelOther);
            platformBody.getLocalVector(pointVelOther.subtract(pointVelPlatform), relativeVel);
            if (relativeVel.y < -1 * PHYSICS_2D_PTM_RATIO) //if moving down faster than PHYSICS_2D_PTM_RATIO pixel/s (1m/s), handle as before
              return; //point is moving into platform, leave contact solid and exit
            else if (relativeVel.y < 1 * PHYSICS_2D_PTM_RATIO) {
                //if moving slower than PHYSICS_2D_PTM_RATIO pixel/s (1m/s)
                //borderline case, moving only slightly out of platform
                platformBody.getLocalPoint(points[i], relativePoint);
                var platformFaceY = selfCollider.worldAABB.height / 2; //front of platform, should only used on a box collider

                if (relativePoint.y > platformFaceY - 0.1 * PHYSICS_2D_PTM_RATIO) return; //contact point is less than 3.2pixel (10cm) inside front face of platfrom
              } else {//moving up faster than 1 m/s
                }
          } // store disabled state to contact


          contact.disabled = true;
        };

        return OneWayPlatform;
      }(Component)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=one-way-platform.js.map